#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <cstdlib>


using namespace std;

int readlength=50;
bool issingleend=true;

int processonefile(string filestr){
	const char* filename=filestr.c_str();
	cout<<"Processing "<<filename<<"...."<<endl;
	ifstream ifs(filename);
	string ofsname(filename);
	ofsname+=".out";
	ofstream ofs(ofsname.c_str());
	if(!ifs.is_open() || !ofs.is_open()){
		cerr<<"Error opening files "<<filename<<endl;
		return -1;
	}
	int nreads=0;
	while(true){
		string line1,line2;
		string line3,line4;
		getline(ifs,line1);
		getline(ifs,line2);
		if(issingleend==false){
			getline(ifs,line3);
			getline(ifs,line4);
		}
		if(ifs.eof())break;
		nreads++;
		if(nreads%100000==1)cout<<"Processing "<<nreads<<" reads.\n";
		if(line2.size()!=readlength)continue;
		if(issingleend==false && line4.size()!=readlength)continue;
		ofs<<line1<<endl;
		ofs<<line2<<endl;
		if(issingleend==false){
			ofs<<line3<<endl;
			ofs<<line4<<endl;
		}

	}
	cout<<"Total: "<<nreads<<" records.\n";
	ofs.close();
	ifs.close();
	return 0;

}

int main(int argc,char* argv[]){
	vector<string> allfiles;
	if(argc<2){
		cout<<"This program is used to filter reads in fasta file with length not equal to a given number.\n";
		cout<<"Usage: filterfastareadlen [options] fastafile1,fastafile2,....\n";
		cout<<"Options:\n";
		cout<<"-l readlen	Specify the desired read length.\n";
		cout<<"-s 		The fasta file is single-ended (one read consists of 2 lines.\n";
		cout<<"-p		The fasta file is paired-ended (one read consists of 4 lines.\n";
		return -1;
	}
	for(int i=1;i<argc;i++){
		if(string(argv[i])=="-l"){
			if(i<argc-1)
				readlength=atoi(argv[i+1]);
			i++;
		}
		else if(string(argv[i])=="-p"){
			issingleend=false;
		}
		else if(string(argv[i])=="-s"){
			issingleend=true;
		}
		else{
			allfiles.push_back(string(argv[i]));
		}
	}
	if(issingleend==true)
		cout<<"Processing single-end reads.\n";
	else
		cout<<"Processing paired-end reads.\n";
	cout<<"Read length: "<<readlength<<endl;
	for(int i=0;i<allfiles.size();i++){
		if(processonefile(allfiles[i])==-1){
			cerr<<"Error processing file "<<allfiles[i]<<endl;
		}
	}
	return 0;
}
