#include <iostream>
#include <fstream>
#include <string>
#include "instance.h"

using namespace std;

/*
Check if for one instance, there's at least one read covering junction between starte and ende, or one read within exon starte.
*/
bool checkreads(Instance& ins, int starte,int ende){
	for(int i=0;i<ins.readPattern.size();i++){
		if(ins.readPattern[i].size()!=4){
			cerr<<"Error: incorrect size of instance read pattern!\n";
			return false;
		}
            if(starte==ende){
	      	if( (ins.readPattern[i][0]==starte 
		      	|| ins.readPattern[i][1]==ende)
			      && ins.readCount[i]>0)
      		return true;
	      	if( (ins.readPattern[i][2]==starte 
		      	|| ins.readPattern[i][3]==ende )
			      && ins.readCount[i]>0)
      		return true;
            }
		if(ins.readPattern[i][0]==starte 
			&& ins.readPattern[i][1]==ende
			&& ins.readCount[i]>0)
		return true;
		if(ins.readPattern[i][2]==starte 
			&& ins.readPattern[i][3]==ende
			&& ins.readCount[i]>0)
		return true;
	}
	return false;
}

int main(int argc, char* argv[]){
	if(argc<2){
		cerr<<"Usage: findeffectiveisoform [isoinfer instance file]\n";
		cerr<<"This program is used to output all effective isoforms: isoforms with every junction covered by at least 1 read.\n";
		return -1;
	}
	vector<Instance> result;
	readInstance(string(argv[1]), result,-1);
	//for(int i=0;i<result.size();i++) printInstance(cout, result[i]);
	for(int i=0;i<result.size();i++){
		//check each isoform in each instance; if each exon and each junction is covered by at least one read, output it as effective isoform
		for(int j=0;j<result[i].isoforms.size();j++){
			vector<int> & oneiso=result[i].isoforms[j];
			bool iseffective=true;
			int previso=-1;
			for(int k=0;k<oneiso.size();k++){
				if(oneiso[k]==1){
					if(checkreads(result[i], k,k)==false){iseffective=false;break;}
					if(previso!=-1 && checkreads(result[i],previso,k)==false){iseffective=false;break;}
					previso=k;
				}
			}
			if(iseffective==true){
				cout<<result[i].isoformNames[j]<<endl;
			}
			
		} 
	}
	return 0;
}
