#include <iostream>
#include <vector>
#include <fstream>
#include <string>
#include <iterator>
#include <sstream>
#include <algorithm>
#include <cstdlib>


using namespace std;

void printmsg(){
	cerr<<"Usage: getsambound [OPTIONS] <-|in.sam>\n";
	cerr<<"OPTIONS:\n";
	cerr<<"-t <s|b>			Specify the type of the input file, either sam (s) or bam (b). Default bam.\n";
}


int main(int argc, char* argv[]){
	
	if(argc <2){
		printmsg();
		return 1;
	}
	string filename(argv[argc-1]);
	
	ifstream ifs;
	if(filename!="-"){
		ifs.open(filename.c_str());
		if(!ifs.is_open()){
			cerr<<"Error opening file "<<filename<<endl;
			return 1;
		}
	}
	
	istream &fifs=filename=="-"?cin:ifs;

	while(true){
		
		string oneline;
		getline(ifs,oneline);
		if(ifs.eof())break;
		istringstream iss(oneline);
		vector<string> tokens;
		copy(istream_iterator<string>(iss), istream_iterator<string>(),
			back_inserter<vector<string> >(tokens));
		
		cout<<tokens.size()<<endl;
	}

	
	return 0;
}
