/*
*/
#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;

int main(int argc, char* argv[]){
	if (argc!=2){
		cout<<"This program is used to extract known gene range from isoinfer benchmark instance file.\n";
		cout<<"Usage: knownGeneExtractorC {isoinfer instance file}.\n";
		return -1;
	}
	ifstream ifs(argv[1]);
	if(!ifs.is_open()){
		cerr<<"Error opening file "<<argv[1]<<endl;
		return -1;
	}
	bool issegs=false;
	
	long starti=-1,endi=-1;
	string chrname;
	char ori;
	int instcounter=0;
	while(true){
		string oneline;
		getline(ifs,oneline);
		if(ifs.eof())break;
		stringstream ss(oneline);
		string firstchr;
		ss>>firstchr;	
		if(firstchr=="segs"){
			issegs=true;
			instcounter++;
			starti=-1;
			endi=-1;
			continue;
		}
		if(firstchr=="len"){
			issegs=false;
			cout<<instcounter<<"\t"<<chrname<<"\t"<<ori<<"\t"<<starti<<"\t"<<endi<<endl;
			continue;
		}
		if(issegs){
			chrname=firstchr;
			ss>>ori;
			long si,ei;
			ss>>si>>ei;
			if(starti==-1){starti=si;endi=ei;}
			else{
				if(si<starti)starti=si;
				if(ei>endi)endi=ei;
			}
		}
	}
	ifs.close();

	return 0;
}
