/**
The program is used to split pair-end read fasta/fastq files into two separate fasta/fastq files
*/

#include <iostream>
#include <fstream>
#include <string>
using namespace std;


int main(int argc, char* argv[]){
    cout<<"The program is used to split pair-end read fasta/fastq files into two separate fasta/fastq files.\n";
    int nlines=2;
    cout<<nlines<<endl;
    if(argc<2){
	cerr<<"Error: not enough parameters.\n";
	return -1;
    }
    ifstream ifs(argv[1]);
    if(!ifs.is_open()){
	cerr<<"Error opening files.\n";
	return -1;
    }
    string ostr1(argv[1]), ostr2(argv[1]);
    ostr1+=".part1";
    ostr2+=".part2";
    ofstream ofs1(ostr1.c_str());
    ofstream ofs2(ostr2.c_str());
    int ncount=0;
    string oneline;
    while(!ifs.eof()){
	getline(ifs,oneline);
	if(oneline.size()<1)break;
        if(ncount%(2*nlines)<nlines){
		ofs1<<oneline<<endl;
	}
	else
		ofs2<<oneline<<endl;
	ncount++;
    }
    ofs1.close();
    ofs2.close();
    ifs.close();
    return 0;
}
