#include <iostream>
#include <fstream>
#include <string>
#include <sstream>


using namespace std;


int main(int argc, char* argv[]){
	cout<<"This program is used to split paired-end sam file into two separate sam files, each corresponding to sam file of one pair-end read.\n";
	cout<<"We use this program to convert pair-end sam files into single-end sam files, which are required at step 3 of the scripture walkthrough example.\n";
	cout<<"Notice that the last character of the read name must be 1 or 2.\n";

	if(argc!=2)return -1;
	ifstream ifs(argv[1]);
	if(!ifs.is_open()){
		cerr<<"Error opening file "<<argv[1]<<endl;
		return -1;
	}
	string of1(argv[1]),of2(argv[1]);
	of1+=".part1.sam";
	of2+=".part2.sam";
	ofstream ofs1(of1.c_str());
	ofstream ofs2(of2.c_str());
	if(!ofs1.is_open() || !ofs2.is_open()){
		cerr<<"Error opening output files.\n";
		return -1;
	}

	string oneline;

	long ncount=0;
	while(true){
		getline(ifs,oneline);
		//jump two lines
		if(ifs.eof())break;
		if(oneline[0]=='@')continue;//jump two header lines
		ncount++;
		stringstream ss(oneline);
		string chrname;
		ss>>chrname;
		
		//flag
		int flag;
		ss>>flag;

		//current position
		int curpos=(int)ss.tellg();
		
		//parse chrname, remove portions between 7th and end of ':'s.
		//If there are '/'s at the end, these part will not be removed.
		int semi7=-1;
		int semicount=0;
		int endpt=chrname.size();
		
		for(int i=0;i<chrname.size();i++){
			if(chrname[i]==':')
			{	semicount++;
				if(semicount==7)semi7=i;
			}
			if(chrname[i]=='/' || chrname[i]=='|')endpt=i;
			
		}
		//reset the flags
		flag &= (~ (0x01 | 0x02 | 0x08 | 0x20 | 0x40 | 0x80));
		
		string oneline1st=oneline.substr(0,semi7);//name
		string oneline2nd=oneline.substr(curpos);//parts after flag


		//ignore the "#1" and "#2" mark
		//oneline=oneline1st+oneline2nd;
		if(chrname[chrname.size()-1]=='1'){
			ofs1<<oneline1st<<"\t"<<flag<<oneline2nd<<"\n";
		}
		else if(chrname[chrname.size()-1]=='2'){
			//ofs2<<oneline<<"\n";
			ofs2<<oneline1st<<"\t"<<flag<<oneline2nd<<"\n";
		}
		else{
			cerr<<"Error: incorrect read names "<<chrname<<endl;
		}
	}

	cout<<"Total: "<<ncount<<" reads.\n";
	ofs1.close();
	ofs2.close();
	ifs.close();
	return 0;
}
